@ECHO OFF
::------------------------------Read me--------------------------------------
:: Revision : 2.3.1
::     Date : 2016.01.28
::  Created : 2015.11.09
::  Purpose : Make media thumbnail
::    usege : Make_Thumbnail [media file name]
::---------------------------------------------------------------------------
SET split=30
SET layout=5
SET size=214x120
SET extended=jpg
::---------------------------------------------------------------------------
SET fontfile=D:\ffmpeg\LED_font.ttf
SET FFmpeg_path=D:\ffmpeg
SET version=2.3.1
::--------------------------------
:: get media info
::--------------------------------
SET isStop=1
SET isStamp=1

SET total_time=
SET argvs=%*

setlocal disabledelayedexpansion 2>nul
SET infile=

:inargv
rem echo ---------[%1%]---------
SET v1=%~1
IF not defined v1 goto endinargv

IF /I "%v1%" == "-i"  (SET infile="%~2" & shift /1)
IF /I "%v1%" == "-t"  (SET /a _split=%2& shift /1)
IF /I "%v1%" == "-l"  (SET /a _layout=%2& shift /1)
IF /I "%v1%" == "-s"  (SET _size=%2& shift /1)
IF /I "%v1%" == "-e"  (SET _extended="%~2"& shift /1)
IF /I "%v1%" == "-ns" (SET isStop=0)
IF /I "%v1%" == "-nt" (SET isStamp=0)

IF /I "%v1:~0,1%" NEQ "-" (SET infile="%~1")

shift /1
goto inargv

:endinargv

IF defined _split SET /a split=%_split%
IF defined _layout SET /a layout=%_layout%
IF defined _extended SET extended=%_extended:"=%

SET isImg=0
for %%i in (bmp gif jpg jpeg pcx png sgi tga tif tiff) do (
    IF /I "%extended%" == "%%i" SET isImg=1)

IF "%isImg%" == "0" (
	::ECHO input parameter ["%argvs%"]
	ECHO invalid extended name '%_extended%' [-E]
	IF %isStop% == 1 PAUSE>NUL
	EXIT /b)

IF %split% LEQ 0 (
    ::ECHO input parameter ["%argvs%"]
    ECHO split number of total tiles can't less equal to zero '%_split%' [-T]
	IF %isStop% == 1 PAUSE>NUL
	EXIT /b)

IF not defined _layout SET /a _layout=%layout%

IF %layout% LEQ 0                          (
    ::ECHO input parameter ["%argvs%"]
    ECHO X tiles of layout can't less equal to zero '%_layout%' [-L]
	IF %isStop% == 1 PAUSE>NUL
	EXIT /b)

IF not defined _size SET _size=%size%
FOR /F "delims=x tokens=1,2" %%i IN ("%_size%") DO SET /a __w=%%i&SET __h=%%j

SET vsize=1
IF not defined __w SET vsize=0& goto vsize
IF not defined __h SET vsize=0& goto vsize
IF %__w% LEQ 0 SET vsize=0& GOTO vsize
IF %__h% LEQ 0 SET vsize=0& GOTO vsize

:vsize
IF "%vsize%"=="1" (SET size=%_size%)
IF "%vsize%"=="0" (
    ::ECHO input parameter ["%argvs%"]
    ECHO invalid size of one tile '%_size%' [-S] [WxH]
	IF %isStop% == 1 PAUSE>NUL
	EXIT /b)
	
SET PATH=%PATH%;%FFmpeg_path%
IF not defined infile (
ECHO %~n0 Version %version% Copyright (c^) 2015-2016 the NLSoft developers
ECHO Usage:
ECHO   %~n0 [-T num] [-L num] [-S WxH] [-NS] [-NT] [[-I] infile] [-E ext]
ECHO     -T  number of total tiles (default 30^)
ECHO     -L  number of X tiles (default 5^)
ECHO     -S  size of one tile [width]x[height] (default 214x120^)
ECHO     -E  extended name of the thumbnail image (default jpg^) 
ECHO         bmp gif jpg jpeg pcx png sgi tga tif tiff
ECHO     -NT not timestamp
ECHO     -NS not suspends processing of a batch program
ECHO     -I  media file name, had best use double quotation marks 
ECHO.
ECHO Example:
ECHO   %~n0 "D:\Video\sample.mp4" -ns
ECHO   %~n0 -t 30 -l 5 -s 214x120 -ns -i "D:\Video\sample.mp4"
    rem ECHO input media file.
	IF %isStop% == 1 PAUSE>NUL
	EXIT /b)

IF NOT EXIST %fontfile% (
    ECHO check font file LED_font.ttf
	IF %isStop% == 1 PAUSE>NUL
	EXIT /b)

::dosname to linux name
::D:\ffmpeg\LED_font.ttf --> D\:/ffmpeg/LED_font.ttf
SET fontfile=%fontfile:/=\%
SET fontfile=%fontfile:\=/%
SET fontfile=%fontfile::=\:%

TITLE Make thumbnail %version%

rem mode con cols=82 lines=14 & color 08

SET isechoc=true
@echoc 01 "test">nul 2>nul
IF "%ERRORLEVEL%" NEQ "0" (SET isechoc=false& call :initColorPrint)

SET begin_time=%date:~0,10% %time:~0,11%

setlocal enabledelayedexpansion 2>nul

SET infile=!infile:"=!
SET tmpfile=%TMP%_t1_%RANDOM%
SET tmpImgDir=%TMP%\imgs_%RANDOM%\
IF EXIST %tmpImgDir% RD %tmpImgDir% /S /Q
MD %tmpImgDir%
IF EXIST %tmpfile% DEL %tmpfile%
ffprobe -v fatal -show_error -show_format -show_streams -i "!infile!">%tmpfile%

IF "%ERRORLEVEL%" NEQ "0" (
    ECHO ERROR : ["!infile!"] isn't media file
	IF EXIST %tmpImgDir% RD %tmpImgDir% /S /Q
	IF %isStop% == 1 PAUSE>NUL
	EXIT /b)

SET isVideo=0



FOR /F "usebackq tokens=1,2 delims==" %%i IN (%tmpfile%) DO (
	IF /I "%%i" == "codec_type" IF /I "%%j" == "video" SET isVideo=1
    IF /I "%%i" == "codec_type" IF /I "%%j" == "audio" SET isVideo=2
	IF /I "%%i" == "[FORMAT]" SET isVideo=3
	
	IF "!isVideo!" == "1" (
    IF /I "%%i" == "coded_width"       SET coded_width=%%j
	IF /I "%%i" == "coded_height"      SET coded_height=%%j
    IF /I "%%i" == "width"             SET width=%%j
	IF /I "%%i" == "height"            SET height=%%j

    IF /I "%%i" == "duration"          SET duration=%%j
    IF /I "%%i" == "nb_frames"         SET nb_frames=%%j
    IF /I "%%i" == "avg_frame_rate"    SET avg_frame_rate=%%j
	)
	IF "!isVideo!" == "3" (
		IF "!duration!" == "N/A" (
			IF /I "%%i" == "duration"  SET duration=%%j
		)
	)	
)
IF EXIST %TMP%_t1 DEL %tmpfile%

IF "%duration%" == "N/A" (
    ECHO ERROR : duration N/A.
	IF EXIST %tmpImgDir% RD %tmpImgDir% /S /Q
	IF %isStop% == 1 PAUSE>NUL
    EXIT /b)

FOR /F "delims=. tokens=1,2" %%i IN ("%duration%") DO SET _num=%%i&SET _dot=%%j000
SET duration_ms=%_num%%_dot:~0,3%

IF "%duration%" == "" (
    ECHO ERROR : duration empty.
	IF EXIST %tmpImgDir% RD %tmpImgDir% /S /Q
	IF %isStop% == 1 PAUSE>NUL
    EXIT /b)

IF /I "%coded_height%" == "0" (SET coded_height=%height% & SET coded_width=%width%)
FOR /F "delims=x tokens=1,2" %%i IN ("%size%") DO (
    SET /a _w=%%i &SET _h=%%j & SET /a _h2=%%i*%coded_height%/%coded_width%)

SET /a _h_shift=%_h2%-%_h%
IF %_h_shift% LSS 0 SET /a _h_shift=%_h_shift%*-1
IF %_h_shift% GEQ 10 SET /a _h=_h2
SET /a _h3=%_h%%%2
IF %_h3% EQU 1 SET /a _h=%_h%-1
SET size=%_w%x%_h%

SET /a sec=%_num%
SET /a tmin=%sec%/60
SET /a tsec=%sec%-%tmin%*60
SET /a thour=%tmin%/60
SET /a tmin=%tmin%-%thour%*60
IF %thour% LEQ 9 (SET thour=0%thour%)
IF %tmin%  LEQ 9 (SET tmin=0%tmin%)
IF %tsec%  LEQ 9 (SET tsec=0%tsec%)
SET duration_str=%thour%:%tmin%:%tsec%.%_dot:~0,3%

SET /a avg_frame_rate_tmp=1000*%avg_frame_rate%
SET avg_frame_rate_str=%avg_frame_rate_tmp:~0,-3%.%avg_frame_rate_tmp:~-3%
IF "%isechoc%"=="true" (echoc 0F "media info") ELSE (call :colorPrint 0F "media info")
ECHO.

SET /p a= filename       <nul
IF "%isechoc%"=="true" (echoc 0E "!infile!" & ECHO.) ELSE (call :colorPrint 0E "!infile!" /n)

SET /p a= resolution    <nul
SET resolution= %coded_width% x %coded_height%
IF "%isechoc%"=="true" (echoc 0E "%resolution%" & ECHO.) ELSE (call :colorPrint 0E "%resolution%" /n)

SET /p a= duration       %duration_ms%ms = <nul
SET /p a= %duration%s = <nul
IF "%isechoc%"=="true" (echoc 0E "%duration_str%") ELSE (call :colorPrint 0E "%duration_str%")
ECHO.

SET /p a= frames         <nul
IF "%isechoc%"=="true" (echoc 0E "%nb_frames%") ELSE (call :colorPrint 0E "%nb_frames%")
ECHO f
SET /p a= frame_rate     %avg_frame_rate% = <nul
IF "%isechoc%"=="true" (echoc 0E "%avg_frame_rate_str%" & ECHO.) ELSE (call :colorPrint 0E "%avg_frame_rate_str%" /n)

SET /a stepms=%duration_ms%/(%split%+1)
IF "%isechoc%"=="true" (echoc 0F "output info") ELSE (call :colorPrint 0F "output info")
ECHO.

SET /p a= split          <nul
IF "%isechoc%"=="true" (echoc 0A "%split% / %layout%" & ECHO.) ELSE (call :colorPrint 0A "%split% / %layout%" /n)
SET /p a= step           %duration_ms% / %split% = <nul

IF "%isechoc%"=="true" (echoc 0A "%stepms%") ELSE (call :colorPrint 0A "%stepms%")
ECHO ms

SET /p a= tile size      <nul
SET image_size=%_w% x %_h%
IF "%isechoc%"=="true" (echoc 0A "%image_size%" & ECHO.) ELSE (call :colorPrint 0A "%image_size%" /n)

::--------------------------------
:: make thumbnail images
::--------------------------------
SET /a fontsize=%coded_height%/8
SET /a fontsize2=%fontsize%/4
SET /p a= <nul
SET percent_max=72
SET len=
FOR /L %%i IN (1,1,%percent_max%) DO SET len=!len! 
IF "!isechoc!"=="true" (echoc 88 "!len!") ELSE ( call :colorPrint 88 "!len!" )
FOR /L %%i IN (1,1,%percent_max%) DO SET /p a=<nul
SET /a percent_bar_old=0
FOR /L %%i IN (1,1,%split%) DO (
    SET /a pos=%%i*%stepms%
	SET sec=!pos:~0,-3!
	SET dot=!pos:~-3!
	IF not defined sec SET sec=0
	
	SET /a percent=100*%%i/%split%
	SET /a percent_bar=%percent_max%*!percent!/100
	TITLE Make thumbnail %version% - !percent!%%
	
	SET /a tmin=!sec!/60
	SET /a tsec=!sec!-!tmin!*60
	SET /a thour=!tmin!/60
	SET /a tmin=!tmin!-!thour!*60
	
	IF !thour! LEQ 9 (SET thour=0!thour!)
	IF !tmin!  LEQ 9 (SET tmin=0!tmin!)
	IF !tsec!  LEQ 9 (SET tsec=0!tsec!)

	IF %%i LSS 100 (SET tn=0%%i)
	IF %%i LSS 10  (SET tn=00%%i)
	IF %%i GEQ 100 (SET tn=%%i)

	SET /a percent_bar_step=!percent_bar!-!percent_bar_old!
	
	IF !percent_bar_step! GEQ 1 (
	SET onestepbar=

	FOR /L %%i IN (1,1,!percent_bar_step!) DO SET onestepbar=!onestepbar!
	IF "%isechoc%"=="true" (echoc 77 !onestepbar!
	) ELSE (SET onestepbar=!onestepbar:= !& SET /p a=!onestepbar!<nul) )
	
	SET /a percent_bar_old=%percent_max%*!percent!/100
	SET vf=-vf drawtext='fontfile=%fontfile%:x=10:y=h-%fontsize%+%fontsize2%:fontsize=%fontsize%:fontcolor=#f0f0f0:shadowcolor=#303030:shadowx=1:shadowy=1:rate=1:text=!tn!-!thour!\:!tmin!\:!tsec!.!dot!:expansion=normal:start_number=0:borderw=0:bordercolor=#303030:box=0:boxcolor=#303030@0.2'
	IF "%isStamp%" == "0" SET vf=
	ffmpeg -v fatal -ss !sec!.!dot! -i "!infile!" -an -y -vframes 1 -s %size% !vf! "%tmpImgDir%t!tn!.!extended!"
)
FOR /L %%i IN (1,1,%percent_max%) DO SET /p a=<nul
SET /p a=!len!<nul
FOR /L %%i IN (1,1,%percent_max%) DO SET /p a=<nul

SET /p a=<nul
TITLE Make thumbnail %version%

::--------------------------------
:: make thumbnail
::--------------------------------

SET allfn=
SET /a iLine=1

DIR %tmpImgDir%\*.%extended% /b/w/n/on>%tmpImgDir%_img.txt
FOR /f "eol=# delims=" %%i IN (%tmpImgDir%_img.txt) DO (
    SET allfn=!allfn! -i "%%i"
    SET /a iLine=!iLine!+1)

DEL %tmpImgDir%_img.txt

SET /a iLine=!iLine!-1
SET /a width=!iLine!*%_w%

SET /a w=%layout%
SET /a h=!iLine!/!w!
SET /a mod=!iLine!-!h!*!w!
IF !mod! NEQ 0 (SET /a h=!h!+1)
SET /a w1=!w!*%_w%
SET /a h1=!h!*%_h%

SET outFile="!infile!.%w%x%h%.%extended%"
SET isFullName=!infile:~1,1!
IF "%isFullName%" NEQ ":" (SET outFile="%cd%\!infile!.%w%x%h%.%extended%")

setlocal disabledelayedexpansion 2>nul

pushd %tmpImgDir%
ffmpeg -v fatal %allfn% -filter_complex concat=n=%iLine%,tile=%w%x%h%,scale=%w1%x%h1% %outFile% -y
%cmd%
popd

IF EXIST %tmpImgDir% rd %tmpImgDir% /S /Q
SET end_time=%date:~0,10% %time%

SET /p a= elapsed time  <nul
call :Fun_CalculateTotalTime %begin_time:~11,11% %end_time:~11,11%
SET elapsed_time=[%begin_time:~11,11% - %end_time:~11,11%] = %total_time:~0,12%
SET /p a= <nul

SET betime1=%begin_time:~11,11%
SET betime1=%betime1: =%
SET betime2=%end_time:~11,11%
SET betime2=%betime2: =%

SET betime=%betime1% - %betime2%

IF "%isechoc%"=="true" (
    echoc 08 "%betime% = "
    echoc 0B "%total_time:~0,12% "
) ELSE (
	call :colorPrint 08 "%betime% = "
    call :colorPrint 0B "%total_time:~0,12% ")

SET /p a=                  <nul
ECHO.
SET /p a= image name     <nul
IF "%isechoc%"=="true" (echoc 0A %outFile%) ELSE (call :colorPrint 0A %outFile%)
ECHO.

IF "%isechoc%"=="false" (call :cleanupColorPrint)

::ECHO.
::ECHO 

IF %isStop% == 1 PAUSE>NUL
EXIT /b

::---------------------------------------------------------------------------
:: Purpose : echo with different colors in the Windows batch file
::---------------------------------------------------------------------------
:colorPrint Color  Str  [/n]
SET "str=%~2"
call :colorPrintVar %1 str %3
EXIT /b

:colorPrintVar  Color  StrVar  [/n]
IF not defined %~2 EXIT /b
setlocal enableDelayedExpansion 2>nul
SET "str=a%DEL%!%~2:\=a%DEL%\..\%DEL%%DEL%%DEL%!"
SET "str=!str:/=a%DEL%/..\%DEL%%DEL%%DEL%!"
SET "str=!str:"=\"!"
PUSHD "%temp%"
findstr /p /A:%1 "." "!str!\..\x" nul
IF /i "%~3"=="/n" ECHO.
EXIT /b

:initColorPrint
FOR /F "tokens=1,2 delims=#" %%a in ('"prompt #$H#$E# & ECHO  on & FOR %%b in (1) DO rem"') DO SET "DEL=%%a"
<nul >"%temp%\x" SET /p "=%DEL%%DEL%%DEL%%DEL%%DEL%%DEL%.%DEL%"
EXIT /b

:cleanupColorPrint
DEL "%temp%\x"
EXIT /b
::---------------------------------------------------------------------------

::------------------------------Fun_CalculateTotalTime-----------------------
:: Revision : 1.0.3
::     Date : 2012-09-30
::  Created : 2012-05-19
::  Purpose : Calculate time
::    usege : call :Fun_CalculateTotalTime 01:02:03.400 04:03:10.510 [display]
:: results in TOTAL_TIME Environment variables
::------------------Calculate the total time---------------------------------
::                        012345678901
:: SET      start_pos_tmp=01:02:03.400
:: SET        end_pos_tmp=04:03:10.510
:Fun_CalculateTotalTime
SET start_pos_tmp=%1
SET end_pos_tmp=%2

IF "%start_pos_tmp:~1,1%"==":" SET "start_pos_tmp=0%start_pos_tmp%"
IF "%end_pos_tmp:~1,1%"==":" SET "end_pos_tmp=0%end_pos_tmp%"

SET hour=%start_pos_tmp:~0,2%
SET min=%start_pos_tmp:~3,2%
SET sec=%start_pos_tmp:~6,2%
SET msec=%start_pos_tmp:~9,2%0

rem --------for skip 08 09---------------
IF %hour:~0,1%==0  SET hour=%hour:~1,1%
IF %min:~0,1%==0   SET min=%min:~1,1%
IF %sec:~0,1%==0   SET sec=%sec:~1,1%
IF %msec:~0,1%==0  SET msec=%msec:~1,2%
IF %msec:~0,1%==0  SET msec=%msec:~1,1%

SET /a hour=%hour%
SET /a min=%min%
SET /a sec=%sec%
SET /a msec=%msec%

SET /a start_millsec=%hour%*60*60+%min%*60+%sec%
SET /a start_millsec=%start_millsec%*1000+%msec%

SET ehour=%end_pos_tmp:~0,2%
SET emin=%end_pos_tmp:~3,2%
SET esec=%end_pos_tmp:~6,2%
SET emsec=%end_pos_tmp:~9,2%0

rem --------for skip 08 09---------------
IF %ehour:~0,1%==0  SET ehour=%ehour:~1,1%
IF %emin:~0,1%==0   SET emin=%emin:~1,1%
IF %esec:~0,1%==0   SET esec=%esec:~1,1%
IF %emsec:~0,1%==0  SET emsec=%emsec:~1,2%
IF %emsec:~0,1%==0  SET emsec=%emsec:~1,1%

SET /a ehour=%ehour%
SET /a emin=%emin%
SET /a esec=%esec%
SET /a emsec=%emsec%

SET /a end_millsec=%ehour%*60*60+%emin%*60+%esec%
SET /a end_millsec=%end_millsec%*1000+%emsec%
SET /a total_time_millsec=%end_millsec%-%start_millsec%
SET /a tsec=%total_time_millsec%/1000
SET /a tmsec=%total_time_millsec%-%tsec%*1000
SET /a tmin=%tsec%/60
SET /a tsec=%tsec%-%tmin%*60
SET /a thour=%tmin%/60
SET /a tmin=%tmin%-%thour%*60

IF %thour% LEQ 9 (SET thour=0%thour%)
IF %tmin%  LEQ 9 (SET tmin=0%tmin%)
IF %tsec%  LEQ 9 (SET tsec=0%tsec%)
IF %tmsec%  LEQ 9 (SET tmsec=00%tmsec%) else (IF %tmsec%  LEQ 99 (SET tmsec=0%tmsec%))
SET total_time=%thour%:%tmin%:%tsec%.%tmsec:~0,2%
IF "%3"=="display" (echo [%start_pos_tmp% - %end_pos_tmp%] = %total_time%)
EXIT /b
::------------------Calculate the total time---------------------------------
